/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the StorageAccountCreateParameters class.
 * @constructor
 * The parameters to provide for the account.
 * @member {string} [accountType] Gets or sets the account type. Possible
 * values for this property include: 'Standard_LRS', 'Standard_ZRS',
 * 'Standard_GRS', 'Standard_RAGRS', 'Premium_LRS'.
 * 
 */
function StorageAccountCreateParameters(parameters) {
  StorageAccountCreateParameters['super_'].call(this, parameters);
  if (parameters !== null && parameters !== undefined) {
    if (parameters.accountType !== undefined) {
      this.accountType = parameters.accountType;
    }
  }    
}

util.inherits(StorageAccountCreateParameters, models['Resource']);

/**
 * Validate the payload against the StorageAccountCreateParameters schema
 *
 * @param {JSON} payload
 *
 */
StorageAccountCreateParameters.prototype.serialize = function () {
  var payload = StorageAccountCreateParameters['super_'].prototype.serialize.call(this);
  if (this['accountType'] !== null && this['accountType'] !== undefined) {
    var allowedValues = [ 'Standard_LRS', 'Standard_ZRS', 'Standard_GRS', 'Standard_RAGRS', 'Premium_LRS' ];
    var thisaccountType = this['accountType'];
    if (!allowedValues.some( function(item) { return item === thisaccountType; })) {
      throw new Error(this['accountType'] + ' is not a valid value. The valid values are: ' + allowedValues);
    }
    if (payload['properties'] === null || payload['properties'] === undefined) {
      payload['properties'] = {};
    }
    payload['properties']['accountType'] = this['accountType'];
  }

  return payload;
};

/**
 * Deserialize the instance to StorageAccountCreateParameters schema
 *
 * @param {JSON} instance
 *
 */
StorageAccountCreateParameters.prototype.deserialize = function (instance) {
  StorageAccountCreateParameters['super_'].prototype.deserialize.call(this, instance);
  if (instance) {
    if (instance['properties'] !== null && instance['properties'] !== undefined) {
      if (instance['properties']['accountType'] !== undefined) {
        this['accountType'] = instance['properties']['accountType'];
      }
    }
  }

  return this;
};

module.exports = StorageAccountCreateParameters;
